/* rdp-connection.c generated by valac 0.56.7, the Vala compiler
 * generated from rdp-connection.vala, do not modify */

/* rdp-connection.vala
 *
 * Copyright (C) Red Hat, Inc
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Felipe Borges <felipeborges@gnome.org>
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include "gtk-frdp.h"
#include <gio/gio.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CONNECTIONS_TYPE_CONNECTION (connections_connection_get_type ())
#define CONNECTIONS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONNECTIONS_TYPE_CONNECTION, ConnectionsConnection))
#define CONNECTIONS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONNECTIONS_TYPE_CONNECTION, ConnectionsConnectionClass))
#define CONNECTIONS_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONNECTIONS_TYPE_CONNECTION))
#define CONNECTIONS_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONNECTIONS_TYPE_CONNECTION))
#define CONNECTIONS_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONNECTIONS_TYPE_CONNECTION, ConnectionsConnectionClass))

typedef struct _ConnectionsConnection ConnectionsConnection;
typedef struct _ConnectionsConnectionClass ConnectionsConnectionClass;
typedef struct _ConnectionsConnectionPrivate ConnectionsConnectionPrivate;

#define CONNECTIONS_TYPE_RDP_CONNECTION (connections_rdp_connection_get_type ())
#define CONNECTIONS_RDP_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONNECTIONS_TYPE_RDP_CONNECTION, ConnectionsRdpConnection))
#define CONNECTIONS_RDP_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONNECTIONS_TYPE_RDP_CONNECTION, ConnectionsRdpConnectionClass))
#define CONNECTIONS_IS_RDP_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONNECTIONS_TYPE_RDP_CONNECTION))
#define CONNECTIONS_IS_RDP_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONNECTIONS_TYPE_RDP_CONNECTION))
#define CONNECTIONS_RDP_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONNECTIONS_TYPE_RDP_CONNECTION, ConnectionsRdpConnectionClass))

typedef struct _ConnectionsRdpConnection ConnectionsRdpConnection;
typedef struct _ConnectionsRdpConnectionClass ConnectionsRdpConnectionClass;
typedef struct _ConnectionsRdpConnectionPrivate ConnectionsRdpConnectionPrivate;

#define CONNECTIONS_TYPE_FRDP_DISPLAY (connections_frdp_display_get_type ())
#define CONNECTIONS_FRDP_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONNECTIONS_TYPE_FRDP_DISPLAY, ConnectionsFrdpDisplay))
#define CONNECTIONS_FRDP_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONNECTIONS_TYPE_FRDP_DISPLAY, ConnectionsFrdpDisplayClass))
#define CONNECTIONS_IS_FRDP_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONNECTIONS_TYPE_FRDP_DISPLAY))
#define CONNECTIONS_IS_FRDP_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONNECTIONS_TYPE_FRDP_DISPLAY))
#define CONNECTIONS_FRDP_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONNECTIONS_TYPE_FRDP_DISPLAY, ConnectionsFrdpDisplayClass))

typedef struct _ConnectionsFrdpDisplay ConnectionsFrdpDisplay;
typedef struct _ConnectionsFrdpDisplayClass ConnectionsFrdpDisplayClass;
enum  {
	CONNECTIONS_RDP_CONNECTION_0_PROPERTY,
	CONNECTIONS_RDP_CONNECTION_WIDGET_PROPERTY,
	CONNECTIONS_RDP_CONNECTION_THUMBNAIL_PROPERTY,
	CONNECTIONS_RDP_CONNECTION_SCALING_PROPERTY,
	CONNECTIONS_RDP_CONNECTION_PORT_PROPERTY,
	CONNECTIONS_RDP_CONNECTION_RESIZE_SUPPORTED_PROPERTY,
	CONNECTIONS_RDP_CONNECTION_SCALE_MODE_PROPERTY,
	CONNECTIONS_RDP_CONNECTION_NUM_PROPERTIES
};
static GParamSpec* connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef struct _ConnectionsFrdpDisplayPrivate ConnectionsFrdpDisplayPrivate;
enum  {
	CONNECTIONS_FRDP_DISPLAY_0_PROPERTY,
	CONNECTIONS_FRDP_DISPLAY_NUM_PROPERTIES
};
static GParamSpec* connections_frdp_display_properties[CONNECTIONS_FRDP_DISPLAY_NUM_PROPERTIES];

struct _ConnectionsConnection {
	GObject parent_instance;
	ConnectionsConnectionPrivate * priv;
	gchar* uuid;
	gboolean connected;
	gboolean need_password;
	gboolean need_username;
};

struct _ConnectionsConnectionClass {
	GObjectClass parent_class;
	void (*send_keys) (ConnectionsConnection* self, guint* keys, gint keys_length1);
	void (*connect_it) (ConnectionsConnection* self);
	void (*disconnect_it) (ConnectionsConnection* self);
	void (*dispose_display) (ConnectionsConnection* self);
	GtkWidget* (*get_widget) (ConnectionsConnection* self);
	void (*set_widget) (ConnectionsConnection* self, GtkWidget* value);
	gboolean (*get_scaling) (ConnectionsConnection* self);
	void (*set_scaling) (ConnectionsConnection* self, gboolean value);
	gint (*get_port) (ConnectionsConnection* self);
	void (*set_port) (ConnectionsConnection* self, gint value);
	GdkPixbuf* (*get_thumbnail) (ConnectionsConnection* self);
	void (*set_thumbnail) (ConnectionsConnection* self, GdkPixbuf* value);
};

struct _ConnectionsRdpConnection {
	ConnectionsConnection parent_instance;
	ConnectionsRdpConnectionPrivate * priv;
};

struct _ConnectionsRdpConnectionClass {
	ConnectionsConnectionClass parent_class;
};

struct _ConnectionsRdpConnectionPrivate {
	ConnectionsFrdpDisplay* display;
	gint _port;
	gboolean _resize_supported;
	gchar* _scale_mode;
};

struct _ConnectionsFrdpDisplay {
	FrdpDisplay parent_instance;
	ConnectionsFrdpDisplayPrivate * priv;
};

struct _ConnectionsFrdpDisplayClass {
	FrdpDisplayClass parent_class;
};

static gint ConnectionsRdpConnection_private_offset;
static gpointer connections_rdp_connection_parent_class = NULL;
static gpointer connections_frdp_display_parent_class = NULL;

VALA_EXTERN GType connections_connection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConnectionsConnection, g_object_unref)
VALA_EXTERN GType connections_rdp_connection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConnectionsRdpConnection, g_object_unref)
VALA_EXTERN GType connections_frdp_display_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConnectionsFrdpDisplay, g_object_unref)
VALA_EXTERN void connections_connection_connect_it (ConnectionsConnection* self);
VALA_EXTERN void connections_connection_disconnect_it (ConnectionsConnection* self);
VALA_EXTERN void connections_connection_dispose_display (ConnectionsConnection* self);
VALA_EXTERN void connections_connection_send_keys (ConnectionsConnection* self,
                                       guint* keys,
                                       gint keys_length1);
VALA_EXTERN GtkWidget* connections_connection_get_widget (ConnectionsConnection* self);
VALA_EXTERN void connections_connection_set_widget (ConnectionsConnection* self,
                                        GtkWidget* value);
VALA_EXTERN GdkPixbuf* connections_connection_get_thumbnail (ConnectionsConnection* self);
VALA_EXTERN void connections_connection_set_thumbnail (ConnectionsConnection* self,
                                           GdkPixbuf* value);
VALA_EXTERN gboolean connections_connection_get_scaling (ConnectionsConnection* self);
VALA_EXTERN void connections_connection_set_scaling (ConnectionsConnection* self,
                                         gboolean value);
VALA_EXTERN gint connections_connection_get_port (ConnectionsConnection* self);
VALA_EXTERN void connections_connection_set_port (ConnectionsConnection* self,
                                      gint value);
VALA_EXTERN ConnectionsRdpConnection* connections_rdp_connection_new (const gchar* uuid);
VALA_EXTERN ConnectionsRdpConnection* connections_rdp_connection_construct (GType object_type,
                                                                const gchar* uuid);
VALA_EXTERN ConnectionsConnection* connections_connection_construct (GType object_type);
VALA_EXTERN ConnectionsRdpConnection* connections_rdp_connection_new_from_uri (const gchar* uri);
VALA_EXTERN ConnectionsRdpConnection* connections_rdp_connection_construct_from_uri (GType object_type,
                                                                         const gchar* uri);
VALA_EXTERN void connections_connection_set_uri (ConnectionsConnection* self,
                                     const gchar* value);
static void connections_rdp_connection_real_connect_it (ConnectionsConnection* base);
VALA_EXTERN const gchar* connections_connection_get_username (ConnectionsConnection* self);
VALA_EXTERN const gchar* connections_connection_get_password (ConnectionsConnection* self);
VALA_EXTERN void connections_connection_handle_auth (ConnectionsConnection* self);
VALA_EXTERN const gchar* connections_connection_get_host (ConnectionsConnection* self);
static void connections_rdp_connection_real_disconnect_it (ConnectionsConnection* base);
static void connections_rdp_connection_real_dispose_display (ConnectionsConnection* base);
static void connections_rdp_connection_real_send_keys (ConnectionsConnection* base,
                                                guint* keyvals,
                                                gint keyvals_length1);
static void connections_rdp_connection_on_rdp_auth_credential_cb (ConnectionsRdpConnection* self);
static void connections_rdp_connection_on_rdp_connection_error_cb (ConnectionsRdpConnection* self,
                                                            const gchar* reason);
VALA_EXTERN void connections_connection_delete_auth_credentials (ConnectionsConnection* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
VALA_EXTERN void connections_connection_delete_auth_credentials_finish (ConnectionsConnection* self,
                                                            GAsyncResult* _res_);
VALA_EXTERN void connections_connection_set_password (ConnectionsConnection* self,
                                          const gchar* value);
VALA_EXTERN void connections_connection_set_username (ConnectionsConnection* self,
                                          const gchar* value);
VALA_EXTERN void connections_connection_on_connection_error_cb (ConnectionsConnection* self,
                                                    const gchar* reason);
static void connections_rdp_connection_on_rdp_connection_connected_cb (ConnectionsRdpConnection* self);
VALA_EXTERN void connections_rdp_connection_scale (ConnectionsRdpConnection* self);
VALA_EXTERN const gchar* connections_rdp_connection_get_scale_mode (ConnectionsRdpConnection* self);
static void connections_rdp_connection_resize_desktop_to_window (ConnectionsRdpConnection* self);
static void connections_rdp_connection_scale_to_fit_window (ConnectionsRdpConnection* self);
static void connections_rdp_connection_scale_to_original_size (ConnectionsRdpConnection* self);
static void connections_rdp_connection_update_resize_supported (ConnectionsRdpConnection* self);
VALA_EXTERN void connections_rdp_connection_set_resize_supported (ConnectionsRdpConnection* self,
                                                      gboolean value);
VALA_EXTERN gboolean connections_rdp_connection_get_resize_supported (ConnectionsRdpConnection* self);
VALA_EXTERN void connections_rdp_connection_set_scale_mode (ConnectionsRdpConnection* self,
                                                const gchar* value);
static GObject * connections_rdp_connection_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
VALA_EXTERN ConnectionsFrdpDisplay* connections_frdp_display_new (void);
VALA_EXTERN ConnectionsFrdpDisplay* connections_frdp_display_construct (GType object_type);
static void _connections_rdp_connection_on_rdp_connection_error_cb_frdp_display_rdp_error (FrdpDisplay* _sender,
                                                                                    const gchar* object,
                                                                                    gpointer self);
static void _connections_rdp_connection_on_rdp_connection_connected_cb_frdp_display_rdp_connected (FrdpDisplay* _sender,
                                                                                            gpointer self);
VALA_EXTERN void connections_connection_auth_failed (ConnectionsConnection* self,
                                         const gchar* reason);
static void _connections_connection_auth_failed_frdp_display_rdp_auth_failure (FrdpDisplay* _sender,
                                                                        const gchar* object,
                                                                        gpointer self);
static void _connections_rdp_connection_scale_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                 GtkAllocation* allocation,
                                                                 gpointer self);
static void _connections_rdp_connection_scale_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void _connections_rdp_connection_update_resize_supported_g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self);
static void connections_rdp_connection_finalize (GObject * obj);
static GType connections_rdp_connection_get_type_once (void);
static void _vala_connections_rdp_connection_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_connections_rdp_connection_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static gboolean connections_frdp_display_real_authenticate (FrdpDisplay* base,
                                                     gchar** username,
                                                     gchar** password,
                                                     gchar** domain);
static GType connections_frdp_display_get_type_once (void);

static inline gpointer
connections_rdp_connection_get_instance_private (ConnectionsRdpConnection* self)
{
	return G_STRUCT_MEMBER_P (self, ConnectionsRdpConnection_private_offset);
}

ConnectionsRdpConnection*
connections_rdp_connection_construct (GType object_type,
                                      const gchar* uuid)
{
	ConnectionsRdpConnection * self = NULL;
	gchar* _tmp0_;
#line 87 "../src/rdp-connection.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 87 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) connections_connection_construct (object_type);
#line 88 "../src/rdp-connection.vala"
	_tmp0_ = g_strdup (uuid);
#line 88 "../src/rdp-connection.vala"
	_g_free0 (((ConnectionsConnection*) self)->uuid);
#line 88 "../src/rdp-connection.vala"
	((ConnectionsConnection*) self)->uuid = _tmp0_;
#line 87 "../src/rdp-connection.vala"
	return self;
#line 287 "rdp-connection.c"
}

ConnectionsRdpConnection*
connections_rdp_connection_new (const gchar* uuid)
{
#line 87 "../src/rdp-connection.vala"
	return connections_rdp_connection_construct (CONNECTIONS_TYPE_RDP_CONNECTION, uuid);
#line 295 "rdp-connection.c"
}

ConnectionsRdpConnection*
connections_rdp_connection_construct_from_uri (GType object_type,
                                               const gchar* uri)
{
	ConnectionsRdpConnection * self = NULL;
	gchar* _tmp0_;
#line 91 "../src/rdp-connection.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 91 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) connections_connection_construct (object_type);
#line 92 "../src/rdp-connection.vala"
	_tmp0_ = g_uuid_string_random ();
#line 92 "../src/rdp-connection.vala"
	_g_free0 (((ConnectionsConnection*) self)->uuid);
#line 92 "../src/rdp-connection.vala"
	((ConnectionsConnection*) self)->uuid = _tmp0_;
#line 93 "../src/rdp-connection.vala"
	connections_connection_set_uri ((ConnectionsConnection*) self, uri);
#line 91 "../src/rdp-connection.vala"
	return self;
#line 318 "rdp-connection.c"
}

ConnectionsRdpConnection*
connections_rdp_connection_new_from_uri (const gchar* uri)
{
#line 91 "../src/rdp-connection.vala"
	return connections_rdp_connection_construct_from_uri (CONNECTIONS_TYPE_RDP_CONNECTION, uri);
#line 326 "rdp-connection.c"
}

static void
connections_rdp_connection_real_connect_it (ConnectionsConnection* base)
{
	ConnectionsRdpConnection * self;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	ConnectionsFrdpDisplay* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 102 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 103 "../src/rdp-connection.vala"
	if (((ConnectionsConnection*) self)->connected) {
#line 104 "../src/rdp-connection.vala"
		g_signal_emit_by_name ((ConnectionsConnection*) self, "show");
#line 106 "../src/rdp-connection.vala"
		return;
#line 349 "rdp-connection.c"
	}
#line 109 "../src/rdp-connection.vala"
	_tmp1_ = connections_connection_get_username ((ConnectionsConnection*) self);
#line 109 "../src/rdp-connection.vala"
	_tmp2_ = _tmp1_;
#line 109 "../src/rdp-connection.vala"
	if (_tmp2_ == NULL) {
#line 357 "rdp-connection.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 109 "../src/rdp-connection.vala"
		_tmp3_ = connections_connection_get_password ((ConnectionsConnection*) self);
#line 109 "../src/rdp-connection.vala"
		_tmp4_ = _tmp3_;
#line 109 "../src/rdp-connection.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 366 "rdp-connection.c"
	} else {
#line 109 "../src/rdp-connection.vala"
		_tmp0_ = FALSE;
#line 370 "rdp-connection.c"
	}
#line 109 "../src/rdp-connection.vala"
	if (_tmp0_) {
#line 110 "../src/rdp-connection.vala"
		connections_connection_handle_auth ((ConnectionsConnection*) self);
#line 112 "../src/rdp-connection.vala"
		return;
#line 378 "rdp-connection.c"
	}
#line 115 "../src/rdp-connection.vala"
	_tmp5_ = self->priv->display;
#line 115 "../src/rdp-connection.vala"
	_tmp6_ = connections_connection_get_host ((ConnectionsConnection*) self);
#line 115 "../src/rdp-connection.vala"
	_tmp7_ = _tmp6_;
#line 115 "../src/rdp-connection.vala"
	_tmp8_ = connections_connection_get_port ((ConnectionsConnection*) self);
#line 115 "../src/rdp-connection.vala"
	_tmp9_ = _tmp8_;
#line 115 "../src/rdp-connection.vala"
	frdp_display_open_host ((FrdpDisplay*) _tmp5_, _tmp7_, (guint) _tmp9_);
#line 392 "rdp-connection.c"
}

static void
connections_rdp_connection_real_disconnect_it (ConnectionsConnection* base)
{
	ConnectionsRdpConnection * self;
#line 118 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 119 "../src/rdp-connection.vala"
	if (((ConnectionsConnection*) self)->connected) {
#line 403 "rdp-connection.c"
		ConnectionsFrdpDisplay* _tmp0_;
#line 120 "../src/rdp-connection.vala"
		_tmp0_ = self->priv->display;
#line 120 "../src/rdp-connection.vala"
		frdp_display_close ((FrdpDisplay*) _tmp0_);
#line 409 "rdp-connection.c"
	}
#line 121 "../src/rdp-connection.vala"
	((ConnectionsConnection*) self)->connected = FALSE;
#line 413 "rdp-connection.c"
}

static void
connections_rdp_connection_real_dispose_display (ConnectionsConnection* base)
{
	ConnectionsRdpConnection * self;
#line 124 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 422 "rdp-connection.c"
}

static void
connections_rdp_connection_real_send_keys (ConnectionsConnection* base,
                                           guint* keyvals,
                                           gint keyvals_length1)
{
	ConnectionsRdpConnection * self;
#line 127 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 433 "rdp-connection.c"
}

static void
connections_rdp_connection_on_rdp_auth_credential_cb (ConnectionsRdpConnection* self)
{
#line 130 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/rdp-connection.vala"
	((ConnectionsConnection*) self)->need_password = TRUE;
#line 131 "../src/rdp-connection.vala"
	((ConnectionsConnection*) self)->need_username = ((ConnectionsConnection*) self)->need_password;
#line 133 "../src/rdp-connection.vala"
	connections_connection_handle_auth ((ConnectionsConnection*) self);
#line 447 "rdp-connection.c"
}

static void
connections_rdp_connection_on_rdp_connection_error_cb (ConnectionsRdpConnection* self,
                                                       const gchar* reason)
{
#line 136 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/rdp-connection.vala"
	g_return_if_fail (reason != NULL);
#line 137 "../src/rdp-connection.vala"
	connections_connection_disconnect_it ((ConnectionsConnection*) self);
#line 139 "../src/rdp-connection.vala"
	connections_connection_delete_auth_credentials ((ConnectionsConnection*) self, NULL, NULL);
#line 140 "../src/rdp-connection.vala"
	connections_connection_set_password ((ConnectionsConnection*) self, NULL);
#line 140 "../src/rdp-connection.vala"
	connections_connection_set_username ((ConnectionsConnection*) self, NULL);
#line 142 "../src/rdp-connection.vala"
	connections_connection_on_connection_error_cb ((ConnectionsConnection*) self, reason);
#line 468 "rdp-connection.c"
}

static void
connections_rdp_connection_on_rdp_connection_connected_cb (ConnectionsRdpConnection* self)
{
	ConnectionsFrdpDisplay* _tmp0_;
#line 145 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/rdp-connection.vala"
	((ConnectionsConnection*) self)->connected = TRUE;
#line 147 "../src/rdp-connection.vala"
	connections_connection_set_scaling ((ConnectionsConnection*) self, TRUE);
#line 149 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->display;
#line 149 "../src/rdp-connection.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 150 "../src/rdp-connection.vala"
	g_signal_emit_by_name ((ConnectionsConnection*) self, "show");
#line 487 "rdp-connection.c"
}

void
connections_rdp_connection_scale (ConnectionsRdpConnection* self)
{
	ConnectionsFrdpDisplay* _tmp0_;
	ConnectionsFrdpDisplay* _tmp1_;
	ConnectionsFrdpDisplay* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
#line 159 "../src/rdp-connection.vala"
	static GQuark _tmp5_label0 = 0;
#line 159 "../src/rdp-connection.vala"
	static GQuark _tmp5_label1 = 0;
#line 159 "../src/rdp-connection.vala"
	static GQuark _tmp5_label2 = 0;
#line 153 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->display;
#line 154 "../src/rdp-connection.vala"
	if (!frdp_display_is_open ((FrdpDisplay*) _tmp0_)) {
#line 155 "../src/rdp-connection.vala"
		return;
#line 513 "rdp-connection.c"
	}
#line 157 "../src/rdp-connection.vala"
	_tmp1_ = self->priv->display;
#line 157 "../src/rdp-connection.vala"
	_tmp2_ = self->priv->display;
#line 157 "../src/rdp-connection.vala"
	g_object_set ((GtkWidget*) _tmp2_, "expand", FALSE, NULL);
#line 157 "../src/rdp-connection.vala"
	g_object_set ((FrdpDisplay*) _tmp1_, "scaling", FALSE, NULL);
#line 159 "../src/rdp-connection.vala"
	_tmp3_ = self->priv->_scale_mode;
#line 159 "../src/rdp-connection.vala"
	_tmp4_ = _tmp3_;
#line 159 "../src/rdp-connection.vala"
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
#line 159 "../src/rdp-connection.vala"
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("resize-desktop")))) {
#line 159 "../src/rdp-connection.vala"
		switch (0) {
#line 533 "rdp-connection.c"
			default:
			{
#line 161 "../src/rdp-connection.vala"
				connections_rdp_connection_resize_desktop_to_window (self);
#line 162 "../src/rdp-connection.vala"
				break;
#line 540 "rdp-connection.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("fit-window")))) {
#line 159 "../src/rdp-connection.vala"
		switch (0) {
#line 546 "rdp-connection.c"
			default:
			{
#line 164 "../src/rdp-connection.vala"
				connections_rdp_connection_scale_to_fit_window (self);
#line 165 "../src/rdp-connection.vala"
				break;
#line 553 "rdp-connection.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("original")))) {
#line 159 "../src/rdp-connection.vala"
		switch (0) {
#line 559 "rdp-connection.c"
			default:
			{
#line 167 "../src/rdp-connection.vala"
				connections_rdp_connection_scale_to_original_size (self);
#line 168 "../src/rdp-connection.vala"
				break;
#line 566 "rdp-connection.c"
			}
		}
	}
}

static void
connections_rdp_connection_resize_desktop_to_window (ConnectionsRdpConnection* self)
{
	ConnectionsFrdpDisplay* _tmp0_;
#line 172 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->display;
#line 173 "../src/rdp-connection.vala"
	g_object_set ((FrdpDisplay*) _tmp0_, "allow-resize", TRUE, NULL);
#line 582 "rdp-connection.c"
}

static void
connections_rdp_connection_scale_to_fit_window (ConnectionsRdpConnection* self)
{
	ConnectionsFrdpDisplay* _tmp0_;
	ConnectionsFrdpDisplay* _tmp1_;
	ConnectionsFrdpDisplay* _tmp2_;
	ConnectionsFrdpDisplay* _tmp3_;
	ConnectionsFrdpDisplay* _tmp4_;
#line 176 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->display;
#line 177 "../src/rdp-connection.vala"
	_tmp1_ = self->priv->display;
#line 177 "../src/rdp-connection.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 177 "../src/rdp-connection.vala"
	g_object_set ((FrdpDisplay*) _tmp0_, "scaling", TRUE, NULL);
#line 178 "../src/rdp-connection.vala"
	_tmp2_ = self->priv->display;
#line 178 "../src/rdp-connection.vala"
	_tmp3_ = self->priv->display;
#line 178 "../src/rdp-connection.vala"
	g_object_set ((GtkWidget*) _tmp3_, "height-request", 0, NULL);
#line 178 "../src/rdp-connection.vala"
	g_object_set ((GtkWidget*) _tmp2_, "width-request", 0, NULL);
#line 179 "../src/rdp-connection.vala"
	_tmp4_ = self->priv->display;
#line 179 "../src/rdp-connection.vala"
	g_object_set ((FrdpDisplay*) _tmp4_, "allow-resize", FALSE, NULL);
#line 615 "rdp-connection.c"
}

static void
connections_rdp_connection_scale_to_original_size (ConnectionsRdpConnection* self)
{
	ConnectionsFrdpDisplay* _tmp0_;
#line 182 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->display;
#line 183 "../src/rdp-connection.vala"
	g_object_set ((FrdpDisplay*) _tmp0_, "allow-resize", FALSE, NULL);
#line 628 "rdp-connection.c"
}

static void
connections_rdp_connection_update_resize_supported (ConnectionsRdpConnection* self)
{
	ConnectionsFrdpDisplay* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 186 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->display;
#line 187 "../src/rdp-connection.vala"
	g_object_get ((FrdpDisplay*) _tmp0_, "resize-supported", &_tmp1_, NULL);
#line 187 "../src/rdp-connection.vala"
	_tmp2_ = _tmp1_;
#line 187 "../src/rdp-connection.vala"
	connections_rdp_connection_set_resize_supported (self, _tmp2_);
#line 647 "rdp-connection.c"
}

static GtkWidget*
connections_rdp_connection_real_get_widget (ConnectionsConnection* base)
{
	GtkWidget* result;
	ConnectionsRdpConnection* self;
	ConnectionsFrdpDisplay* _tmp0_;
#line 30 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 31 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->display;
#line 31 "../src/rdp-connection.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp0_) : NULL;
#line 31 "../src/rdp-connection.vala"
	return result;
#line 664 "rdp-connection.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "../src/rdp-connection.vala"
	return self ? g_object_ref (self) : NULL;
#line 672 "rdp-connection.c"
}

static void
connections_rdp_connection_real_set_widget (ConnectionsConnection* base,
                                            GtkWidget* value)
{
	ConnectionsRdpConnection* self;
	ConnectionsFrdpDisplay* _tmp0_;
#line 26 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 27 "../src/rdp-connection.vala"
	_tmp0_ = _g_object_ref0 (CONNECTIONS_IS_FRDP_DISPLAY (value) ? ((ConnectionsFrdpDisplay*) value) : NULL);
#line 27 "../src/rdp-connection.vala"
	_g_object_unref0 (self->priv->display);
#line 27 "../src/rdp-connection.vala"
	self->priv->display = _tmp0_;
#line 26 "../src/rdp-connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_WIDGET_PROPERTY]);
#line 691 "rdp-connection.c"
}

static GdkPixbuf*
connections_rdp_connection_real_get_thumbnail (ConnectionsConnection* base)
{
	GdkPixbuf* result;
	ConnectionsRdpConnection* self;
	GtkAllocation alloc = {0};
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkAllocation _tmp2_ = {0};
	cairo_surface_t* surface = NULL;
	GtkAllocation _tmp3_;
	GtkAllocation _tmp4_;
	cairo_surface_t* _tmp5_;
	cairo_t* context = NULL;
	cairo_t* _tmp6_;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GtkAllocation _tmp10_;
	GtkAllocation _tmp11_;
	GdkPixbuf* _tmp12_;
#line 40 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 42 "../src/rdp-connection.vala"
	_tmp0_ = connections_connection_get_widget ((ConnectionsConnection*) self);
#line 42 "../src/rdp-connection.vala"
	_tmp1_ = _tmp0_;
#line 42 "../src/rdp-connection.vala"
	gtk_widget_get_allocation (_tmp1_, &_tmp2_);
#line 42 "../src/rdp-connection.vala"
	alloc = _tmp2_;
#line 44 "../src/rdp-connection.vala"
	_tmp3_ = alloc;
#line 44 "../src/rdp-connection.vala"
	_tmp4_ = alloc;
#line 44 "../src/rdp-connection.vala"
	_tmp5_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp3_.width, _tmp4_.height);
#line 44 "../src/rdp-connection.vala"
	surface = _tmp5_;
#line 45 "../src/rdp-connection.vala"
	_tmp6_ = cairo_create (surface);
#line 45 "../src/rdp-connection.vala"
	context = _tmp6_;
#line 46 "../src/rdp-connection.vala"
	_tmp7_ = connections_connection_get_widget ((ConnectionsConnection*) self);
#line 46 "../src/rdp-connection.vala"
	_tmp8_ = _tmp7_;
#line 46 "../src/rdp-connection.vala"
	g_signal_emit_by_name (_tmp8_, "draw", context, &_tmp9_);
#line 48 "../src/rdp-connection.vala"
	_tmp10_ = alloc;
#line 48 "../src/rdp-connection.vala"
	_tmp11_ = alloc;
#line 48 "../src/rdp-connection.vala"
	_tmp12_ = gdk_pixbuf_get_from_surface (surface, 0, 0, _tmp10_.width, _tmp11_.height);
#line 48 "../src/rdp-connection.vala"
	result = _tmp12_;
#line 48 "../src/rdp-connection.vala"
	_cairo_destroy0 (context);
#line 48 "../src/rdp-connection.vala"
	_cairo_surface_destroy0 (surface);
#line 48 "../src/rdp-connection.vala"
	return result;
#line 757 "rdp-connection.c"
}

static void
connections_rdp_connection_real_set_thumbnail (ConnectionsConnection* base,
                                               GdkPixbuf* value)
{
	ConnectionsRdpConnection* self;
#line 36 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 37 "../src/rdp-connection.vala"
	return;
#line 769 "rdp-connection.c"
}

static gboolean
connections_rdp_connection_real_get_scaling (ConnectionsConnection* base)
{
	gboolean result;
	ConnectionsRdpConnection* self;
	ConnectionsFrdpDisplay* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 57 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 58 "../src/rdp-connection.vala"
	if (!((ConnectionsConnection*) self)->connected) {
#line 59 "../src/rdp-connection.vala"
		result = TRUE;
#line 59 "../src/rdp-connection.vala"
		return result;
#line 788 "rdp-connection.c"
	}
#line 61 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->display;
#line 61 "../src/rdp-connection.vala"
	g_object_get ((FrdpDisplay*) _tmp0_, "scaling", &_tmp1_, NULL);
#line 61 "../src/rdp-connection.vala"
	_tmp2_ = _tmp1_;
#line 61 "../src/rdp-connection.vala"
	result = _tmp2_;
#line 61 "../src/rdp-connection.vala"
	return result;
#line 800 "rdp-connection.c"
}

static void
connections_rdp_connection_real_set_scaling (ConnectionsConnection* base,
                                             gboolean value)
{
	ConnectionsRdpConnection* self;
	ConnectionsFrdpDisplay* _tmp0_;
#line 53 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 54 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->display;
#line 54 "../src/rdp-connection.vala"
	frdp_display_set_scaling ((FrdpDisplay*) _tmp0_, value);
#line 53 "../src/rdp-connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_SCALING_PROPERTY]);
#line 817 "rdp-connection.c"
}

static gint
connections_rdp_connection_real_get_port (ConnectionsConnection* base)
{
	gint result;
	ConnectionsRdpConnection* self;
#line 65 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 65 "../src/rdp-connection.vala"
	result = self->priv->_port;
#line 65 "../src/rdp-connection.vala"
	return result;
#line 831 "rdp-connection.c"
}

static void
connections_rdp_connection_real_set_port (ConnectionsConnection* base,
                                          gint value)
{
	ConnectionsRdpConnection* self;
	gint old_value;
#line 65 "../src/rdp-connection.vala"
	self = (ConnectionsRdpConnection*) base;
#line 65 "../src/rdp-connection.vala"
	old_value = connections_rdp_connection_real_get_port (base);
#line 65 "../src/rdp-connection.vala"
	if (old_value != value) {
#line 65 "../src/rdp-connection.vala"
		self->priv->_port = value;
#line 65 "../src/rdp-connection.vala"
		g_object_notify_by_pspec ((GObject *) self, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_PORT_PROPERTY]);
#line 850 "rdp-connection.c"
	}
}

gboolean
connections_rdp_connection_get_resize_supported (ConnectionsRdpConnection* self)
{
	gboolean result;
#line 66 "../src/rdp-connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 66 "../src/rdp-connection.vala"
	result = self->priv->_resize_supported;
#line 66 "../src/rdp-connection.vala"
	return result;
#line 864 "rdp-connection.c"
}

void
connections_rdp_connection_set_resize_supported (ConnectionsRdpConnection* self,
                                                 gboolean value)
{
	gboolean old_value;
#line 66 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/rdp-connection.vala"
	old_value = connections_rdp_connection_get_resize_supported (self);
#line 66 "../src/rdp-connection.vala"
	if (old_value != value) {
#line 66 "../src/rdp-connection.vala"
		self->priv->_resize_supported = value;
#line 66 "../src/rdp-connection.vala"
		g_object_notify_by_pspec ((GObject *) self, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_RESIZE_SUPPORTED_PROPERTY]);
#line 882 "rdp-connection.c"
	}
}

const gchar*
connections_rdp_connection_get_scale_mode (ConnectionsRdpConnection* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 67 "../src/rdp-connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../src/rdp-connection.vala"
	_tmp0_ = self->priv->_scale_mode;
#line 67 "../src/rdp-connection.vala"
	result = _tmp0_;
#line 67 "../src/rdp-connection.vala"
	return result;
#line 899 "rdp-connection.c"
}

void
connections_rdp_connection_set_scale_mode (ConnectionsRdpConnection* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 67 "../src/rdp-connection.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/rdp-connection.vala"
	old_value = connections_rdp_connection_get_scale_mode (self);
#line 67 "../src/rdp-connection.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 913 "rdp-connection.c"
		gchar* _tmp0_;
#line 67 "../src/rdp-connection.vala"
		_tmp0_ = g_strdup (value);
#line 67 "../src/rdp-connection.vala"
		_g_free0 (self->priv->_scale_mode);
#line 67 "../src/rdp-connection.vala"
		self->priv->_scale_mode = _tmp0_;
#line 67 "../src/rdp-connection.vala"
		g_object_notify_by_pspec ((GObject *) self, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_SCALE_MODE_PROPERTY]);
#line 923 "rdp-connection.c"
	}
}

static void
_connections_rdp_connection_on_rdp_connection_error_cb_frdp_display_rdp_error (FrdpDisplay* _sender,
                                                                               const gchar* object,
                                                                               gpointer self)
{
#line 75 "../src/rdp-connection.vala"
	connections_rdp_connection_on_rdp_connection_error_cb ((ConnectionsRdpConnection*) self, object);
#line 934 "rdp-connection.c"
}

static void
_connections_rdp_connection_on_rdp_connection_connected_cb_frdp_display_rdp_connected (FrdpDisplay* _sender,
                                                                                       gpointer self)
{
#line 76 "../src/rdp-connection.vala"
	connections_rdp_connection_on_rdp_connection_connected_cb ((ConnectionsRdpConnection*) self);
#line 943 "rdp-connection.c"
}

static void
_connections_connection_auth_failed_frdp_display_rdp_auth_failure (FrdpDisplay* _sender,
                                                                   const gchar* object,
                                                                   gpointer self)
{
#line 78 "../src/rdp-connection.vala"
	connections_connection_auth_failed ((ConnectionsConnection*) self, object);
#line 953 "rdp-connection.c"
}

static void
_connections_rdp_connection_scale_gtk_widget_size_allocate (GtkWidget* _sender,
                                                            GtkAllocation* allocation,
                                                            gpointer self)
{
#line 79 "../src/rdp-connection.vala"
	connections_rdp_connection_scale ((ConnectionsRdpConnection*) self);
#line 963 "rdp-connection.c"
}

static void
_connections_rdp_connection_scale_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 81 "../src/rdp-connection.vala"
	connections_rdp_connection_scale ((ConnectionsRdpConnection*) self);
#line 973 "rdp-connection.c"
}

static void
_connections_rdp_connection_update_resize_supported_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self)
{
#line 82 "../src/rdp-connection.vala"
	connections_rdp_connection_update_resize_supported ((ConnectionsRdpConnection*) self);
#line 983 "rdp-connection.c"
}

static GObject *
connections_rdp_connection_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ConnectionsRdpConnection * self;
	ConnectionsFrdpDisplay* _tmp0_;
	ConnectionsFrdpDisplay* _tmp1_;
	ConnectionsFrdpDisplay* _tmp2_;
	ConnectionsFrdpDisplay* _tmp3_;
	ConnectionsFrdpDisplay* _tmp4_;
	ConnectionsFrdpDisplay* _tmp5_;
	ConnectionsFrdpDisplay* _tmp6_;
	ConnectionsFrdpDisplay* _tmp7_;
	ConnectionsFrdpDisplay* _tmp8_;
	ConnectionsFrdpDisplay* _tmp9_;
#line 69 "../src/rdp-connection.vala"
	parent_class = G_OBJECT_CLASS (connections_rdp_connection_parent_class);
#line 69 "../src/rdp-connection.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 69 "../src/rdp-connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONNECTIONS_TYPE_RDP_CONNECTION, ConnectionsRdpConnection);
#line 70 "../src/rdp-connection.vala"
	_tmp0_ = connections_frdp_display_new ();
#line 70 "../src/rdp-connection.vala"
	g_object_ref_sink (_tmp0_);
#line 70 "../src/rdp-connection.vala"
	_g_object_unref0 (self->priv->display);
#line 70 "../src/rdp-connection.vala"
	self->priv->display = _tmp0_;
#line 71 "../src/rdp-connection.vala"
	_tmp1_ = self->priv->display;
#line 71 "../src/rdp-connection.vala"
	_tmp2_ = self->priv->display;
#line 71 "../src/rdp-connection.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp2_, TRUE);
#line 71 "../src/rdp-connection.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 72 "../src/rdp-connection.vala"
	_tmp3_ = self->priv->display;
#line 72 "../src/rdp-connection.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp3_, "username", (GObject*) self, "username", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 73 "../src/rdp-connection.vala"
	_tmp4_ = self->priv->display;
#line 73 "../src/rdp-connection.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp4_, "password", (GObject*) self, "password", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 75 "../src/rdp-connection.vala"
	_tmp5_ = self->priv->display;
#line 75 "../src/rdp-connection.vala"
	g_signal_connect_object ((FrdpDisplay*) _tmp5_, "rdp-error", (GCallback) _connections_rdp_connection_on_rdp_connection_error_cb_frdp_display_rdp_error, self, 0);
#line 76 "../src/rdp-connection.vala"
	_tmp6_ = self->priv->display;
#line 76 "../src/rdp-connection.vala"
	g_signal_connect_object ((FrdpDisplay*) _tmp6_, "rdp-connected", (GCallback) _connections_rdp_connection_on_rdp_connection_connected_cb_frdp_display_rdp_connected, self, 0);
#line 78 "../src/rdp-connection.vala"
	_tmp7_ = self->priv->display;
#line 78 "../src/rdp-connection.vala"
	g_signal_connect_object ((FrdpDisplay*) _tmp7_, "rdp-auth-failure", (GCallback) _connections_connection_auth_failed_frdp_display_rdp_auth_failure, (ConnectionsConnection*) self, 0);
#line 79 "../src/rdp-connection.vala"
	_tmp8_ = self->priv->display;
#line 79 "../src/rdp-connection.vala"
	g_signal_connect_object ((GtkWidget*) _tmp8_, "size-allocate", (GCallback) _connections_rdp_connection_scale_gtk_widget_size_allocate, self, 0);
#line 81 "../src/rdp-connection.vala"
	g_signal_connect_object ((GObject*) self, "notify::scale-mode", (GCallback) _connections_rdp_connection_scale_g_object_notify, self, 0);
#line 82 "../src/rdp-connection.vala"
	_tmp9_ = self->priv->display;
#line 82 "../src/rdp-connection.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::resize-supported", (GCallback) _connections_rdp_connection_update_resize_supported_g_object_notify, self, 0);
#line 84 "../src/rdp-connection.vala"
	((ConnectionsConnection*) self)->need_password = TRUE;
#line 84 "../src/rdp-connection.vala"
	((ConnectionsConnection*) self)->need_username = ((ConnectionsConnection*) self)->need_password;
#line 69 "../src/rdp-connection.vala"
	return obj;
#line 1062 "rdp-connection.c"
}

static void
connections_rdp_connection_class_init (ConnectionsRdpConnectionClass * klass,
                                       gpointer klass_data)
{
#line 23 "../src/rdp-connection.vala"
	connections_rdp_connection_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/rdp-connection.vala"
	g_type_class_adjust_private_offset (klass, &ConnectionsRdpConnection_private_offset);
#line 23 "../src/rdp-connection.vala"
	((ConnectionsConnectionClass *) klass)->connect_it = (void (*) (ConnectionsConnection*)) connections_rdp_connection_real_connect_it;
#line 23 "../src/rdp-connection.vala"
	((ConnectionsConnectionClass *) klass)->disconnect_it = (void (*) (ConnectionsConnection*)) connections_rdp_connection_real_disconnect_it;
#line 23 "../src/rdp-connection.vala"
	((ConnectionsConnectionClass *) klass)->dispose_display = (void (*) (ConnectionsConnection*)) connections_rdp_connection_real_dispose_display;
#line 23 "../src/rdp-connection.vala"
	((ConnectionsConnectionClass *) klass)->send_keys = (void (*) (ConnectionsConnection*, guint*, gint)) connections_rdp_connection_real_send_keys;
#line 23 "../src/rdp-connection.vala"
	CONNECTIONS_CONNECTION_CLASS (klass)->get_widget = (GtkWidget* (*) (ConnectionsConnection*)) connections_rdp_connection_real_get_widget;
#line 23 "../src/rdp-connection.vala"
	CONNECTIONS_CONNECTION_CLASS (klass)->set_widget = (void (*) (ConnectionsConnection*, GtkWidget*)) connections_rdp_connection_real_set_widget;
#line 23 "../src/rdp-connection.vala"
	CONNECTIONS_CONNECTION_CLASS (klass)->get_thumbnail = (GdkPixbuf* (*) (ConnectionsConnection*)) connections_rdp_connection_real_get_thumbnail;
#line 23 "../src/rdp-connection.vala"
	CONNECTIONS_CONNECTION_CLASS (klass)->set_thumbnail = (void (*) (ConnectionsConnection*, GdkPixbuf*)) connections_rdp_connection_real_set_thumbnail;
#line 23 "../src/rdp-connection.vala"
	CONNECTIONS_CONNECTION_CLASS (klass)->get_scaling = (gboolean (*) (ConnectionsConnection*)) connections_rdp_connection_real_get_scaling;
#line 23 "../src/rdp-connection.vala"
	CONNECTIONS_CONNECTION_CLASS (klass)->set_scaling = (void (*) (ConnectionsConnection*, gboolean)) connections_rdp_connection_real_set_scaling;
#line 23 "../src/rdp-connection.vala"
	CONNECTIONS_CONNECTION_CLASS (klass)->get_port = (gint (*) (ConnectionsConnection*)) connections_rdp_connection_real_get_port;
#line 23 "../src/rdp-connection.vala"
	CONNECTIONS_CONNECTION_CLASS (klass)->set_port = (void (*) (ConnectionsConnection*, gint)) connections_rdp_connection_real_set_port;
#line 23 "../src/rdp-connection.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_connections_rdp_connection_get_property;
#line 23 "../src/rdp-connection.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_connections_rdp_connection_set_property;
#line 23 "../src/rdp-connection.vala"
	G_OBJECT_CLASS (klass)->constructor = connections_rdp_connection_constructor;
#line 23 "../src/rdp-connection.vala"
	G_OBJECT_CLASS (klass)->finalize = connections_rdp_connection_finalize;
#line 23 "../src/rdp-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTIONS_RDP_CONNECTION_WIDGET_PROPERTY, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/rdp-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTIONS_RDP_CONNECTION_THUMBNAIL_PROPERTY, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_THUMBNAIL_PROPERTY] = g_param_spec_object ("thumbnail", "thumbnail", "thumbnail", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/rdp-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTIONS_RDP_CONNECTION_SCALING_PROPERTY, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_SCALING_PROPERTY] = g_param_spec_boolean ("scaling", "scaling", "scaling", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/rdp-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTIONS_RDP_CONNECTION_PORT_PROPERTY, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_PORT_PROPERTY] = g_param_spec_int ("port", "port", "port", G_MININT, G_MAXINT, 3389, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/rdp-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTIONS_RDP_CONNECTION_RESIZE_SUPPORTED_PROPERTY, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_RESIZE_SUPPORTED_PROPERTY] = g_param_spec_boolean ("resize-supported", "resize-supported", "resize-supported", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/rdp-connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTIONS_RDP_CONNECTION_SCALE_MODE_PROPERTY, connections_rdp_connection_properties[CONNECTIONS_RDP_CONNECTION_SCALE_MODE_PROPERTY] = g_param_spec_string ("scale-mode", "scale-mode", "scale-mode", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1117 "rdp-connection.c"
}

static void
connections_rdp_connection_instance_init (ConnectionsRdpConnection * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
#line 23 "../src/rdp-connection.vala"
	self->priv = connections_rdp_connection_get_instance_private (self);
#line 65 "../src/rdp-connection.vala"
	self->priv->_port = 3389;
#line 66 "../src/rdp-connection.vala"
	self->priv->_resize_supported = FALSE;
#line 67 "../src/rdp-connection.vala"
	_tmp0_ = g_strdup ("fit-window");
#line 67 "../src/rdp-connection.vala"
	self->priv->_scale_mode = _tmp0_;
#line 1135 "rdp-connection.c"
}

static void
connections_rdp_connection_finalize (GObject * obj)
{
	ConnectionsRdpConnection * self;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 23 "../src/rdp-connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONNECTIONS_TYPE_RDP_CONNECTION, ConnectionsRdpConnection);
#line 97 "../src/rdp-connection.vala"
	_tmp0_ = connections_connection_get_widget ((ConnectionsConnection*) self);
#line 97 "../src/rdp-connection.vala"
	_tmp1_ = _tmp0_;
#line 97 "../src/rdp-connection.vala"
	_tmp2_ = gtk_widget_get_name (_tmp1_);
#line 97 "../src/rdp-connection.vala"
	_tmp3_ = _tmp2_;
#line 97 "../src/rdp-connection.vala"
	g_debug ("rdp-connection.vala:97: Closing connection with %s", _tmp3_);
#line 99 "../src/rdp-connection.vala"
	connections_connection_disconnect_it ((ConnectionsConnection*) self);
#line 24 "../src/rdp-connection.vala"
	_g_object_unref0 (self->priv->display);
#line 67 "../src/rdp-connection.vala"
	_g_free0 (self->priv->_scale_mode);
#line 23 "../src/rdp-connection.vala"
	G_OBJECT_CLASS (connections_rdp_connection_parent_class)->finalize (obj);
#line 1166 "rdp-connection.c"
}

static GType
connections_rdp_connection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConnectionsRdpConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) connections_rdp_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConnectionsRdpConnection), 0, (GInstanceInitFunc) connections_rdp_connection_instance_init, NULL };
	GType connections_rdp_connection_type_id;
	connections_rdp_connection_type_id = g_type_register_static (CONNECTIONS_TYPE_CONNECTION, "ConnectionsRdpConnection", &g_define_type_info, 0);
	ConnectionsRdpConnection_private_offset = g_type_add_instance_private (connections_rdp_connection_type_id, sizeof (ConnectionsRdpConnectionPrivate));
	return connections_rdp_connection_type_id;
}

GType
connections_rdp_connection_get_type (void)
{
	static volatile gsize connections_rdp_connection_type_id__once = 0;
	if (g_once_init_enter (&connections_rdp_connection_type_id__once)) {
		GType connections_rdp_connection_type_id;
		connections_rdp_connection_type_id = connections_rdp_connection_get_type_once ();
		g_once_init_leave (&connections_rdp_connection_type_id__once, connections_rdp_connection_type_id);
	}
	return connections_rdp_connection_type_id__once;
}

static void
_vala_connections_rdp_connection_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	ConnectionsRdpConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONNECTIONS_TYPE_RDP_CONNECTION, ConnectionsRdpConnection);
#line 23 "../src/rdp-connection.vala"
	switch (property_id) {
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_WIDGET_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		g_value_set_object (value, connections_connection_get_widget ((ConnectionsConnection*) self));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_THUMBNAIL_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		g_value_take_object (value, connections_connection_get_thumbnail ((ConnectionsConnection*) self));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_SCALING_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		g_value_set_boolean (value, connections_connection_get_scaling ((ConnectionsConnection*) self));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_PORT_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		g_value_set_int (value, connections_connection_get_port ((ConnectionsConnection*) self));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_RESIZE_SUPPORTED_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		g_value_set_boolean (value, connections_rdp_connection_get_resize_supported (self));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_SCALE_MODE_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		g_value_set_string (value, connections_rdp_connection_get_scale_mode (self));
#line 23 "../src/rdp-connection.vala"
		break;
#line 1237 "rdp-connection.c"
		default:
#line 23 "../src/rdp-connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/rdp-connection.vala"
		break;
#line 1243 "rdp-connection.c"
	}
}

static void
_vala_connections_rdp_connection_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	ConnectionsRdpConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONNECTIONS_TYPE_RDP_CONNECTION, ConnectionsRdpConnection);
#line 23 "../src/rdp-connection.vala"
	switch (property_id) {
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_WIDGET_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		connections_connection_set_widget ((ConnectionsConnection*) self, g_value_get_object (value));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_THUMBNAIL_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		connections_connection_set_thumbnail ((ConnectionsConnection*) self, g_value_get_object (value));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_SCALING_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		connections_connection_set_scaling ((ConnectionsConnection*) self, g_value_get_boolean (value));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_PORT_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		connections_connection_set_port ((ConnectionsConnection*) self, g_value_get_int (value));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_RESIZE_SUPPORTED_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		connections_rdp_connection_set_resize_supported (self, g_value_get_boolean (value));
#line 23 "../src/rdp-connection.vala"
		break;
#line 23 "../src/rdp-connection.vala"
		case CONNECTIONS_RDP_CONNECTION_SCALE_MODE_PROPERTY:
#line 23 "../src/rdp-connection.vala"
		connections_rdp_connection_set_scale_mode (self, g_value_get_string (value));
#line 23 "../src/rdp-connection.vala"
		break;
#line 1293 "rdp-connection.c"
		default:
#line 23 "../src/rdp-connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/rdp-connection.vala"
		break;
#line 1299 "rdp-connection.c"
	}
}

static gboolean
connections_frdp_display_real_authenticate (FrdpDisplay* base,
                                            gchar** username,
                                            gchar** password,
                                            gchar** domain)
{
	ConnectionsFrdpDisplay * self;
	gchar* _vala_username = NULL;
	gchar* _vala_password = NULL;
	gchar* _vala_domain = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean result;
#line 192 "../src/rdp-connection.vala"
	self = (ConnectionsFrdpDisplay*) base;
#line 193 "../src/rdp-connection.vala"
	g_object_get ((FrdpDisplay*) self, "username", &_tmp0_, NULL);
#line 193 "../src/rdp-connection.vala"
	_tmp1_ = _tmp0_;
#line 193 "../src/rdp-connection.vala"
	_g_free0 (_vala_username);
#line 193 "../src/rdp-connection.vala"
	_vala_username = _tmp1_;
#line 194 "../src/rdp-connection.vala"
	g_object_get ((FrdpDisplay*) self, "password", &_tmp2_, NULL);
#line 194 "../src/rdp-connection.vala"
	_tmp3_ = _tmp2_;
#line 194 "../src/rdp-connection.vala"
	_g_free0 (_vala_password);
#line 194 "../src/rdp-connection.vala"
	_vala_password = _tmp3_;
#line 195 "../src/rdp-connection.vala"
	_g_free0 (_vala_domain);
#line 195 "../src/rdp-connection.vala"
	_vala_domain = NULL;
#line 197 "../src/rdp-connection.vala"
	result = TRUE;
#line 197 "../src/rdp-connection.vala"
	if (username) {
#line 197 "../src/rdp-connection.vala"
		*username = _vala_username;
#line 1346 "rdp-connection.c"
	} else {
#line 197 "../src/rdp-connection.vala"
		_g_free0 (_vala_username);
#line 1350 "rdp-connection.c"
	}
#line 197 "../src/rdp-connection.vala"
	if (password) {
#line 197 "../src/rdp-connection.vala"
		*password = _vala_password;
#line 1356 "rdp-connection.c"
	} else {
#line 197 "../src/rdp-connection.vala"
		_g_free0 (_vala_password);
#line 1360 "rdp-connection.c"
	}
#line 197 "../src/rdp-connection.vala"
	if (domain) {
#line 197 "../src/rdp-connection.vala"
		*domain = _vala_domain;
#line 1366 "rdp-connection.c"
	} else {
#line 197 "../src/rdp-connection.vala"
		_g_free0 (_vala_domain);
#line 1370 "rdp-connection.c"
	}
#line 197 "../src/rdp-connection.vala"
	return result;
#line 1374 "rdp-connection.c"
}

ConnectionsFrdpDisplay*
connections_frdp_display_construct (GType object_type)
{
	ConnectionsFrdpDisplay * self = NULL;
#line 191 "../src/rdp-connection.vala"
	self = (ConnectionsFrdpDisplay*) g_object_new (object_type, NULL);
#line 191 "../src/rdp-connection.vala"
	return self;
#line 1385 "rdp-connection.c"
}

ConnectionsFrdpDisplay*
connections_frdp_display_new (void)
{
#line 191 "../src/rdp-connection.vala"
	return connections_frdp_display_construct (CONNECTIONS_TYPE_FRDP_DISPLAY);
#line 1393 "rdp-connection.c"
}

static void
connections_frdp_display_class_init (ConnectionsFrdpDisplayClass * klass,
                                     gpointer klass_data)
{
#line 191 "../src/rdp-connection.vala"
	connections_frdp_display_parent_class = g_type_class_peek_parent (klass);
#line 191 "../src/rdp-connection.vala"
	((FrdpDisplayClass *) klass)->authenticate = (gboolean (*) (FrdpDisplay*, gchar**, gchar**, gchar**)) connections_frdp_display_real_authenticate;
#line 1404 "rdp-connection.c"
}

static void
connections_frdp_display_instance_init (ConnectionsFrdpDisplay * self,
                                        gpointer klass)
{
}

static GType
connections_frdp_display_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConnectionsFrdpDisplayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) connections_frdp_display_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConnectionsFrdpDisplay), 0, (GInstanceInitFunc) connections_frdp_display_instance_init, NULL };
	GType connections_frdp_display_type_id;
	connections_frdp_display_type_id = g_type_register_static (frdp_display_get_type (), "ConnectionsFrdpDisplay", &g_define_type_info, 0);
	return connections_frdp_display_type_id;
}

GType
connections_frdp_display_get_type (void)
{
	static volatile gsize connections_frdp_display_type_id__once = 0;
	if (g_once_init_enter (&connections_frdp_display_type_id__once)) {
		GType connections_frdp_display_type_id;
		connections_frdp_display_type_id = connections_frdp_display_get_type_once ();
		g_once_init_leave (&connections_frdp_display_type_id__once, connections_frdp_display_type_id);
	}
	return connections_frdp_display_type_id__once;
}

